#include <stdio.h>
#include <stdlib.h>
#include "gddcommon.h"
#include "gddblas_host.h"
#include "common_test.h"
#include <time.h>

    double dasum_( int*n, double*xh, int*incx);
int
main( int argc, char const* argv[] )
{
    srand( (unsigned)time( NULL ) );
    int      MAX_DIM = 256;
    int      n = rand( )%MAX_DIM+1;

    double * xh, *xl;
    int      incx = rand( )%MAX_DIM+1;
    int      incy = rand( )%MAX_DIM+1;

    if(
        cudaSuccess != cudaMallocHost( (void **)&xh, incx*n*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&xl, incx*n*sizeof( double ) )
      )
    {
        printf( "Host Malloc Error\n" );
        return -1;
    }


    int i;
    for( i = 0; i < n*incx; i++ )
    {
        xh[i] = drand( );
        xl[i] = dzero( );
    }


    double reth1 ;
    double retl1 ;

    double reth2 ;


#ifdef MULTI
    printf("calling multi-gpu function\n");
    gddasum_host_multigpu_( &n, xh, xl, &incx, &reth1, &retl1 );
#else
    printf("calling single-gpu function\n");
    gddasum_host_( &n, xh, xl, &incx, &reth1, &retl1 );
#endif
    printf("calling single-cpu function\n");
    reth2 = dasum_( &n, xh, &incx);

    dcheck(&reth1,&reth2,1,1);

    cudaFreeHost( xh );
    cudaFreeHost( xl );

    return 0;
}

