#include <stdio.h>
#include "gddcommon.h"
#include "gddblas_host.h"
#include "common_test.h"
#include <time.h>

double ddot_(int  *n, double * xh, int * incx,double* yh,  int*incy);
int
main( int argc, char const* argv[] )
{
	srand((unsigned)time(NULL));
	int MAX_DIM = 256;
    int      n = rand()%MAX_DIM+1;
/*    int      n = 3;*/

    double * xh, *xl, *yh, *yl;
    int      incx = rand()%MAX_DIM+1;
    int      incy = rand()%MAX_DIM+1;


    int sizex = incx*n;
    int sizey = incy*n;
    if(
         cudaSuccess != cudaMallocHost( (void **)&xh, sizex*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&xl, sizex*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&yh, sizey*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&yl, sizey*sizeof( double ) )
      )
    {
        printf( "Host Malloc Error\n" );
        return -1;
    }


    int i;
    for( i = 0; i < sizex; i++ )
    {
        xh[i] = drand();
        xl[i] = drand()*1e-17 ;
    }
    for( i = 0; i < sizey; i++ )
    {
        yh[i] = drand();
        yl[i] = drand()*1e-17;
    }


    double reth = 1.0;
    double retl = 0.0;

    double reth0 = reth;
    double retl0 = retl;

/*    for( i = 0; i < sizex; i++ )*/
/*    {*/
/*        printf( "x::%d,%e,%e\n", i, xh[i], xl[i] );*/
/*    }*/
/*    printf( "###############\n" );*/
/*    for( i = 0; i < sizey; i++ )*/
/*    {*/
/*        printf( "x::%d,%e,%e\n", i, yh[i], yl[i] );*/
/*    }*/
/*    printf( "###############\n" );*/

#ifdef MULTI
    printf("calling multi-gpu function\n");
    gdddot_host_multigpu_( &n, xh, xl, &incx, yh, yl, &incy, &reth, &retl );
#else
    printf("calling single-gpu function\n");
    gdddot_host_( &n, xh, xl, &incx, yh, yl, &incy, &reth, &retl );
#endif
    printf("calling single-cpu function\n");
    reth0 = ddot_( &n, xh,  &incx, yh,  &incy);
    printf( "n:%d,incx:%d,incy:%d\n",n,incx,incy );
    dcheck( &reth,  &reth0,  1, 1 );

    cudaFreeHost( xh );
    cudaFreeHost( xl );
    cudaFreeHost( yh );
    cudaFreeHost( yl );

    return 0;
}

