#include <stdio.h>
#include "gddcommon.h"
#include "gddblas_host.h"
#include "common_test.h"
#include <time.h>

int
main( int argc, char const* argv[] )
{
    srand( (unsigned)time( NULL ) );
    int      MAX_DIM = 256;
    int      m = rand( )%MAX_DIM+1; /* nrowC and nrow op(A) */
    int      n = rand( )%MAX_DIM+1; /* ncolC and ncol op(B) */
/*    int n = 20;*/
/*    int m = 9;*/

    double * xh, *xl, *yh, *yl, *Ah, *Al,*Bh,*Bl;
    int      incx = rand( )%MAX_DIM+1;
    int      incy = rand( )%MAX_DIM+1;
/*    int      incx = 1;*/
/*    int      incy = 1;*/

    int      lda = m;

    int      sizeA =  lda*n;
    int      sizex = incx*m;
    int      sizey = incy*n;


    if(
        cudaSuccess != cudaMallocHost( (void **)&xh,  sizex*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&xl, sizex*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&yh, sizey*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&yl, sizey*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&Ah, sizeA*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&Al, sizeA*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&Bh, sizeA*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&Bl, sizeA*sizeof( double ) )
      )
    {
        printf( "Host Malloc Error\n" );
        return -1;
    }


    int i,j;
    for( i = 0; i < sizex; i++ )
    {
        xh[i] = drand();
        xl[i] = dzero();
    }
    for( i = 0; i < sizey; i++ )
    {
        yh[i] = drand();
        yl[i] = dzero();
    }

    for( i = 0; i < sizeA; i++ )
    {
        Ah[i] = 0.0;
        Al[i] = 0.0;
        Bh[i] = Ah[i];
        Bl[i] = 0.0;
    }


/*    for( i = 0; i < sizex; i++ )*/
/*    {*/
/*        printf( "x::%d,%e,%e\n", i, xh[i], xl[i] );*/
/*    }*/
/*    printf( "###############\n" );*/
/*    for( i = 0; i < sizey; i++ )*/
/*    {*/
/*        printf( "x::%d,%e,%e\n", i, yh[i], yl[i] );*/
/*    }*/
/*    printf( "###############\n" );*/

    double alphah = drand();
    double alphal = 0.0;
    printf("alpha:%e\n",alphah);


#ifdef MULTI
    printf("calling multi-gpu function\n");
    gddger_host_multigpu_( &m, &n, &alphah, &alphal, xh, xl, &incx, yh, yl, &incy, Ah,
		 Al,&lda );
#else
    printf("calling single-gpu function\n");
    gddger_host_( &m, &n, &alphah, &alphal, xh, xl, &incx, yh, yl, &incy, Ah,
		 Al,&lda );
#endif
    printf("calling single-cpu function\n");
    dger_( &m, &n, &alphah,  xh,  &incx, yh,  &incy,Bh,&lda );
    printf("m:%d,n:%d,incx:%d,incy:%d\n",m,n,incx,incy);
/*    for (i = 0; i < m; i++) {*/
/*            for (j = 0; j < n; j++) {*/
/*                    printf("%e,",*(Ah+i+j*m));*/
/*            }*/
/*            printf("\n");*/
/*    }*/

/*            printf("\n");*/
/*    for (i = 0; i < m; i++) {*/
/*            for (j = 0; j < n; j++) {*/
/*                    printf("%e,",*(Bh+i+j*m));*/
/*            }*/
/*            printf("\n");*/
/*    }*/

    dcheck(Ah,Bh,lda,n);


    cudaFreeHost( xh );
    cudaFreeHost( xl );
    cudaFreeHost( yh );
    cudaFreeHost( yl );
    cudaFreeHost( Ah );
    cudaFreeHost( Al );

    return 0;
}

