#include <stdio.h>
#include "gddcommon.h"
#include "gddblas_host.h"
#include "common_test.h"
#include <time.h>

int
main( int argc, char const* argv[] )
{
	srand((unsigned)time(NULL));
	int MAX_DIM = 256;
	int      n = rand()%MAX_DIM+1;

    double * xh, *xl, *yh, *yl,*xh0,*xl0,*yh0,*yl0;
	int     incx = rand()%MAX_DIM+1;
	int     incy = rand()%MAX_DIM+1;
/*    int      incx = 1;*/
/*    int      incy = 1;*/

    if(
        cudaSuccess != cudaMallocHost( (void **)&xh, incx*n*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&xl, incx*n*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&yh, incy*n*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&yl, incy*n*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&xh0, incx*n*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&xl0, incx*n*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&yh0, incy*n*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&yl0, incy*n*sizeof( double ) )
      )
    {
        printf( "Host Malloc Error\n" );
        return -1;
    }


    int i;
    for( i = 0; i < n*incx; i++ )
    {
        xh[i] = drand();
        xl[i] = dzero();
	xh0[i] = xh[i];
	xl0[i] = xl[i];
    }

    for( i = 0; i < n*incy; i++ )
    {
        yh[i] = drand();
        yl[i] = dzero();
        yh0[i] = yh[i];
        yl0[i] = yl[i];
    }

    double paramh[5],paraml[5];


    paramh[0] = (double)(rand()%4-2) ;
    paraml[0] = 0.0;
    paramh[1] = drand();
    paraml[1] = 0.0;
    paramh[2] = drand();
    paraml[2] = 0.0;
    paramh[3] = drand();
    paraml[3] = 0.0;
    paramh[4] = drand();
    paraml[4] = 0.0;


/*    for( i = 0; i < n*incx; i++ )*/
/*    {*/
/*        printf( "x::%d,%e,%e\n", i, xh[i], xl[i] );*/
/*    }*/
/*    printf( "###############\n" );*/
/*    for( i = 0; i < n*incy; i++ )*/
/*    {*/
/*        printf( "x::%d,%e,%e\n", i, yh[i], yl[i] );*/
/*    }*/
/*    printf( "###############\n" );*/

/*    gddrotm_host_( &n, xh, xl, &incx, yh, yl, &incy,paramh,paraml );*/

/*    for( i = 0; i < n*incx; i++ )*/
/*    {*/
/*        printf( "%d,%e,%e\n", i, xh[i], xl[i] );*/
/*    }*/
/*    printf( "###############\n" );*/
/*    for( i = 0; i < n*incy; i++ )*/
/*    {*/
/*        printf( "%d,%e,%e\n", i, yh[i], yl[i] );*/
/*    }*/


#ifdef MULTI
    printf("calling multi-gpu function\n");
    gddrotm_host_multigpu_( &n, xh, xl, &incx, yh, yl, &incy,paramh,paraml );
#else
    printf("calling single-gpu function\n");
    gddrotm_host_( &n, xh, xl, &incx, yh, yl, &incy,paramh,paraml );
#endif
    printf("calling single-cpu function\n");
    drotm_( &n, xh0,  &incx, yh0, &incy,paramh );

    printf("n:%d,incx:%d,incy:%d,flag:%e\n",n,incx,incy,paramh[0]);
    dcheck(xh,xh0,incx*n,1);
    dcheck(yh,yh0,incy*n,1);


/*    for( i = 0; i < n*incx; i++ )*/
/*    {*/
/*        printf( "%d,%e,%e\n", i, xh[i], xl[i] );*/
/*    }*/
/*    printf( "###############\n" );*/
/*    for( i = 0; i < n*incy; i++ )*/
/*    {*/
/*        printf( "%d,%e,%e\n", i, yh[i], yl[i] );*/
/*    }*/




    cudaFreeHost( xh );
    cudaFreeHost( xl );
    cudaFreeHost( yh );
    cudaFreeHost( yl );

    return 0;
}

