#include <stdio.h>
#include "gddcommon.h"
#include "gddblas_host.h"
#include "common_test.h"
#include <time.h>

int
main( int argc, char const* argv[] )
{
	srand((unsigned)time(NULL));
    int      MAX_DIM = 256;
    int      n = rand()%MAX_DIM+1;

    double * xh, *xl,*x0h,*x0l;
    int incx = rand()%MAX_DIM+1;

    int sizex = incx*n;

    if(
        cudaSuccess != cudaMallocHost( (void **)&xh,   sizex*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&xl,  sizex*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&x0h, sizex*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&x0l, sizex*sizeof( double ) )
      )
    {
        printf( "Host Malloc Error\n" );
        return -1;
    }


    int i;
    for( i = 0; i < sizex; i++ )
    {
        xh[i] = drand();
        xl[i] = dzero();
	x0h[i] = xh[i];
	x0l[i] = xl[i];
    }

    double alphah =drand();
    double alphal = dzero();

/*    for (i = 0; i < n*incx; i++) {*/
/*            printf("x::%d,%e,%e\n",i,xh[i],xl[i]);*/
/*    }*/
/*    printf("###############\n");*/

#ifdef MULTI
    printf("calling multi-gpu function\n");
   gddscal_host_multigpu_( &n, &alphah,&alphal,xh, xl, &incx );
#else
    printf("calling single-gpu function\n");
   gddscal_host_( &n, &alphah,&alphal,xh, xl, &incx );
#endif
    printf("calling single-cpu function\n");
   dscal_( &n, &alphah,x0h,  &incx );


   printf("n:%d,incx:%d\n",n,incx);
   dcheck(xh,x0h,sizex,1);
/*    gddscal_host_( &n, &alphah,&alphal,xh, xl, &incx );*/

/*    for (i = 0; i < n*incx; i++) {*/
/*            printf("%d,%e,%e\n",i,xh[i],xl[i]);*/
/*    }*/

    cudaFreeHost( xh );
    cudaFreeHost( xl );

    return 0;
}

