#include <stdio.h>
#include "gddcommon.h"
#include "gddblas_host.h"
#include "common_test.h"
#include <time.h>

int
main( int argc, char const* argv[] )
{
	srand((unsigned)time(NULL));
	int MAX_DIM = 256;

         int i, j;

	int n = rand()%MAX_DIM+1;
/*        int n = 10;*/
	int m= n;
	int lda = n;

        char uplo = getRandomChar("uUlL",4); // 'U' or 'L'

	double *Ah,*Al;


    int incx = rand()%MAX_DIM+1;
    int incy = rand()%MAX_DIM+1;
/*    int incx = 3;*/
/*    int incy = 1;*/
    int sizex,sizey;

	   sizex = incx * n;
	   sizey = incy * n;

   int sizeA = lda*n;

    if(
         cudaSuccess != cudaMallocHost( (void **)&Ah, sizeA*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&Al, sizeA*sizeof( double ) )
      )
    {
        printf( "Host Malloc Error\n" );
        return -1;
    }





   for( i = 0; i < m; i++ )
    {
        for( j = 0; j < n; j++ )
        {
	    Ah[i+j*lda] = drand();
	    Al[i+j*lda] = dzero();
        }
    }


/*    int x, y;*/
/*    for( x = 0; x < m; x++ )*/
/*    {*/
/*        for( y = 0; y < n; y++ )*/
/*        {*/
/*            printf( "%f,", Ah[x+y*lda] );*/
/*        }*/
/*        printf( "\n" );*/
/*    }*/

/*        printf( "****************************\n" );*/




    double * xh, *xl;


    if(
        cudaSuccess != cudaMallocHost( (void **)&xh, sizex*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&xl, sizex*sizeof( double ) )
      )
    {
        printf( "Host Malloc Error\n" );
        return -1;
    }

    for( i = 0; i < sizex; i++ )
    {
	xh[i] = drand();
	xl[i] = dzero();
    }

/*    for (i = 0; i < sizex; i++) {*/
/*            printf("%e,",xh[i]);*/
/*    }*/
/*    printf("\n\n");*/
 
    double * yh, *yl;
    double * yh0, *yl0;


    if(
        cudaSuccess != cudaMallocHost( (void **) &yh, sizey*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&yl, sizey*sizeof( double ) )
      ||  cudaSuccess != cudaMallocHost( (void **) &yh0, sizey*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&yl0, sizey*sizeof( double ) )
      )
    {
        printf( "Host Malloc Error\n" );
        return -1;
    }

    for( i = 0; i <sizey; i++ )
    {
	yh[i] = drand();
	yl[i] = 0.0;
        yh0[i] = yh[i];
        yl0[i] = yl[i];
    }
/* */
/*    for (i = 0; i < sizey; i++) {*/
/*            printf("%e,",yh[i]);*/
/*    }*/
/*    printf("\n\n");*/
 



    double alphah = drand();
    double alphal = 0.0;
    double betah = drand();
    double betal = 0.0;


#ifdef MULTI
    printf("calling multi-gpu function\n");
    gddsymv_host_multigpu_(&uplo,  &n, &alphah,  &alphal, Ah,  Al,  &lda, xh,
	xl,  &incx,  &betah, &betal,  yh,  yl, &incy );
#else
    printf("calling single-gpu function\n");
    gddsymv_host_(&uplo,  &n, &alphah,  &alphal, Ah,  Al,  &lda, xh,
	xl,  &incx,  &betah, &betal,  yh,  yl, &incy );
#endif
    dsymv_(&uplo,  &n, &alphah, Ah,  &lda, xh,
	  &incx,  &betah,  yh0, &incy );


    printf("n:%d,incx:%d,incy:%d\n",n,incx,incy);
    dcheck(yh,yh0,sizey,1);



    cudaFreeHost( Ah );
    cudaFreeHost( Al );
    cudaFreeHost( xh );
    cudaFreeHost( xl );

    return 0;
}

