#include <stdio.h>
#include <stdlib.h>
#include "gddcommon.h"
#include "gddblas_host.h"
#include "common_test.h"

int
main( int argc, char const* argv[] )
{
    srand( (unsigned)time( NULL ) );
    int  MAX_DIM = 256;
    int  m = rand( )%MAX_DIM+1;
/*    int  m = 4;*/
    int  n = m;

    int  lda = m;

    int  i, j, k;

/*    char uplo = 'u';*/
/*    char diag = 'N';*/
/*    char trans = 'N';*/
  char uplo  = getRandomChar("lLuU",4); // 'L' or 'U'
  char trans = getRandomChar("nNtT",4); // 'N' or 'T'
  char diag  = getRandomChar("uUnN",4); // 'U' or 'N'


    int  kl, ku ;


    int kb = rand()%m;
/*    int kb = 2;*/

    if( uplo == 'u' || uplo == 'U' )
    {
        ku = kb;
        kl = 0;
    }
    else
    {
        ku = 0;
        kl = kb;
    }





    double * Ah, *Al, *bAh, *bAl, *hAh, *hAl;
    int  incx = rand( )%MAX_DIM+1;
/*    int  incx = 2;*/
    int      sizex ;

        sizex = incx*n;

    int sizeA = lda*n;

    if(
        cudaSuccess != cudaMallocHost( (void **)&Ah, sizeA*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&Al, sizeA*sizeof( double ) )
      )
    {
        printf( "Host Malloc Error\n" );
        return -1;
    }

    int sizehA = m*n;
    if(
        cudaSuccess != cudaMallocHost( (void **)&hAh, sizeA*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&hAl, sizeA*sizeof( double ) )
      )
    {
        printf( "Host Malloc Error\n" );
        return -1;
    }


    int ldba = ( kl+ku+1 );
    int sizebA = ldba*n;

    if(
        cudaSuccess != cudaMallocHost( (void **)&bAh, sizebA*sizeof( double ) )
      || cudaSuccess !=
        cudaMallocHost( (void **)&bAl, sizebA*sizeof( double ) )
      )
    {
        printf( "Host Malloc Error\n" );
        return -1;
    }


    for( i = 0; i < m; i++ )
    {
        for( j = 0; j < n; j++ )
        {
            Ah[i+j*lda] = drand();
            Al[i+j*lda] = dzero();
        }
    }


/*    int x, y;*/
/*    for( x = 0; x < m; x++ )*/
/*    {*/
/*        for( y = 0; y < n; y++ )*/
/*        {*/
/*            printf( "%f,", Ah[x+y*lda] );*/
/*        }*/
/*        printf( "\n" );*/
/*    }*/

/*    printf( "****************************\n" );*/


    copyToBandMatrix( m, n, lda, kl, ku, Ah, Al, bAh, bAl );

/*    for( x = 0; x < kl+ku+1; x++ )*/
/*    {*/
/*        for( y = 0; y < n; y++ )*/
/*        {*/
/*            printf( "%f,", bAh[x+y*( kl+ku+1 )] );*/
/*        }*/
/*        printf( "\n" );*/
/*    }*/

/*    printf( "****************************\n" );*/


    double * xh, *xl,*zh,*zl;


    if(
        cudaSuccess != cudaMallocHost( (void **)&xh, sizex*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&xl, sizex*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&zh, sizex*sizeof( double ) )
      || cudaSuccess != cudaMallocHost( (void **)&zl, sizex*sizeof( double ) )
      )
    {
        printf( "Host Malloc Error\n" );
        return -1;
    }

    for( i = 0; i < sizex; i++ )
    {
        xh[i] = drand();
        xl[i] = dzero();
	zh[i] = xh[i];
	zl[i] = xl[i];
    }

/*    for( i = 0; i < sizex; i++ )*/
/*    {*/
/*        printf( "%e,", xh[i] );*/
/*    }*/
/*    printf( "\n\n" );*/

    double alphah = rand();
    double alphal = 0.0;
    double betah = rand();
    double betal = 0.0;


#ifdef MULTI
    printf("calling multi-gpu function\n");
    gddtbsv_host_multigpu_( &uplo, &trans, &diag, &n, &kb, bAh,  bAl,  &ldba, zh, zl,
                  &incx );

#else
    printf("calling single-gpu function\n");
    gddtbsv_host_( &uplo, &trans, &diag, &n, &kb, bAh,  bAl,  &ldba, zh, zl,
                  &incx );
#endif
    printf("calling single-cpu function\n");
    dtbsv_( &uplo, &trans, &diag, &n, &kb, bAh,  &ldba, xh, 
                  &incx );
  printf("uplo:%c,trans:%c,diag:%c,n:%d,k:%d,incx:%d,\n",uplo,trans,diag,n,kb,incx);
    dcheck(xh,zh,sizex,1);


    cudaFreeHost( Ah );
    cudaFreeHost( Al );
    cudaFreeHost( xh );
    cudaFreeHost( xl );
    cudaFreeHost( zh );
    cudaFreeHost( zl );

    return 0;
}

