#include <stdio.h>
#include "gddcommon.h"
#include "gddblas_host.h"
#include "common_test.h"
#include <time.h>

int
main( int argc, char const* argv[] )
{
	srand((unsigned)time(NULL));
	int MAX_DIM = 256;
    int      n = rand()%MAX_DIM+1;

    cuDoubleComplex * xh, *xl, *yh, *yl;
    int      incx = rand()%MAX_DIM+1;
    int      incy = rand()%MAX_DIM+1;

    if(
        cudaSuccess != cudaMallocHost( (void **)&xh, incx*n*sizeof( cuDoubleComplex ) )
      || cudaSuccess != cudaMallocHost( (void **)&xl, incx*n*sizeof( cuDoubleComplex ) )
      || cudaSuccess != cudaMallocHost( (void **)&yh, incy*n*sizeof( cuDoubleComplex ) )
      || cudaSuccess != cudaMallocHost( (void **)&yl, incy*n*sizeof( cuDoubleComplex ) )
      )
    {
        printf( "Host Malloc Error\n" );
        return -1;
    }


    int i;
    for( i = 0; i < n*incx; i++ )
    {
        xh[i] = zrand();
        xl[i] = zzero();
    }
    for( i = 0; i < n*incy; i++ )
    {
        yh[i] = zrand();
        yl[i] = zzero();
    }


    cuDoubleComplex reth,reth0 ;
    cuDoubleComplex retl,retl0 ;

/*    for( i = 0; i < n*incx; i++ )*/
/*    {*/
/*        printf( "x::%d,%e+%eI,%e+%eI\n", i, xh[i].x,xh[i].y, xl[i].x,xl[i].y  );*/
/*    }*/
/*    printf( "###############\n" );*/
/*    for( i = 0; i < n*incy; i++ )*/
/*    {*/
/*        printf( "x::%d,%e+%eI,%e+%eI\n", i, yh[i].x, yh[i].y, yl[i].x, yl[i].y );*/
/*    }*/
/*    printf( "###############\n" );*/

/*   int t = gdddot_host_multigpu_( &n, xh, xl, &incx, yh, yl, &incy, &reth, &retl );*/
#ifdef MULTI
    printf("calling multi-gpu function\n");
    gddzdotu_host_multigpu_( &n, xh, xl, &incx, yh, yl, &incy, &reth, &retl );
/*    printf( "reth:%e+%eI,retf:%e+%eI\n", reth.x, reth.y, retl.x, retl.y );*/
/*    for( i = 0; i < n*incx; i++ )*/
/*    {*/
/*        xh[i] = cuConj(xh[i]);*/
/*        xl[i] = cuConj(xl[i]);*/
/*    }*/
/* */
#else
    printf("calling single-gpu function\n");
    gddzdotu_host_( &n, xh, xl, &incx, yh, yl, &incy, &reth, &retl );
#endif
    printf("calling single-cpu function\n");
    zdotu_( &reth0,&n, xh,  &incx, yh,  &incy);

    zcheck( &reth,  &reth0,  1, 1 );

    cudaFreeHost( xh );
    cudaFreeHost( xl );
    cudaFreeHost( yh );
    cudaFreeHost( yl );

    return 0;
}

