#include <stdio.h>
#include "gddcommon.h"
#include "gddblas_host.h"
#include "common_test.h"
#include <time.h>

int
main( int argc, char const* argv[] )
{
	srand((unsigned)time(NULL));
	int MAX_DIM = 256;

         int i, j;

	int n = rand()%MAX_DIM+1;
/*        int n = 10;*/
	int m= n;
	int lda = n;

	char uplo = 'l';

	cuDoubleComplex *Ah,*Al;


    int incx = rand()%MAX_DIM+1;
    int incy = rand()%MAX_DIM+1;
/*    int incx = 3;*/
/*    int incy = 1;*/
    int sizex,sizey;

	   sizex = incx * n;
	   sizey = incy * n;

   int sizeA = lda*n;

    if(
         cudaSuccess != cudaMallocHost( (void **)&Ah, sizeA*sizeof( cuDoubleComplex ) )
      || cudaSuccess != cudaMallocHost( (void **)&Al, sizeA*sizeof( cuDoubleComplex ) )
      )
    {
        printf( "Host Malloc Error\n" );
        return -1;
    }





   for( i = 0; i < m; i++ )
    {
        for( j = 0; j < n; j++ )
        {
/*            Ah[i+j*lda] = drand();*/
/*            Al[i+j*lda] = drand()*1e-17;*/
	    Ah[i+j*lda] = (cuDoubleComplex ) make_cuDoubleComplex(i+1 + j*lda,i);
	    Al[i+j*lda] = zzero();
        }
    }


/*    int x, y;*/
/*    for( x = 0; x < m; x++ )*/
/*    {*/
/*        for( y = 0; y < n; y++ )*/
/*        {*/
/*            printf( "%f,", Ah[x+y*lda] );*/
/*        }*/
/*        printf( "\n" );*/
/*    }*/
/*        printf( "****************************\n" );*/




    cuDoubleComplex * xh, *xl;


    if(
        cudaSuccess != cudaMallocHost( (void **)&xh, sizex*sizeof( cuDoubleComplex ) )
      || cudaSuccess != cudaMallocHost( (void **)&xl, sizex*sizeof( cuDoubleComplex ) )
      )
    {
        printf( "Host Malloc Error\n" );
        return -1;
    }

    for( i = 0; i < sizex; i++ )
    {
	xh[i] = zrand();
	xl[i] = zzero();
    }

/*    for (i = 0; i < sizex; i++) {*/
/*            printf("%e,",xh[i]);*/
/*    }*/
/*    printf("\n\n");*/
 
    cuDoubleComplex * yh, *yl;
    cuDoubleComplex * yh0, *yl0;


    if(
        cudaSuccess != cudaMallocHost( (void **) &yh, sizey*sizeof( cuDoubleComplex ) )
      || cudaSuccess != cudaMallocHost( (void **)&yl, sizey*sizeof( cuDoubleComplex ) )
      ||  cudaSuccess != cudaMallocHost( (void **) &yh0, sizey*sizeof( cuDoubleComplex ) )
      || cudaSuccess != cudaMallocHost( (void **)&yl0, sizey*sizeof( cuDoubleComplex ) )
      )
    {
        printf( "Host Malloc Error\n" );
        return -1;
    }

    for( i = 0; i <sizey; i++ )
    {
/*        yh[i] = drand();*/
/*        yl[i] = 0.0;*/
	yh[i] = zrand();
	yl[i] = zzero();
        yh0[i] = yh[i];
        yl0[i] = yl[i];
    }
/* */
/*    for (i = 0; i < sizey; i++) {*/
/*            printf("%e,",yh[i]);*/
/*    }*/
/*    printf("\n\n");*/
 



    cuDoubleComplex alphah = zrand();
    cuDoubleComplex alphal = zzero();
    cuDoubleComplex betah = zrand();
    cuDoubleComplex betal = zzero();


#ifdef MULTI
    printf("calling multi-gpu function\n");
    gddzhemv_host_multigpu_(&uplo,  &n, &alphah,  &alphal, Ah,  Al,  &lda, xh,
	xl,  &incx,  &betah, &betal,  yh,  yl, &incy );
#else
    printf("calling single-gpu function\n");
    gddzhemv_host_(&uplo,  &n, &alphah,  &alphal, Ah,  Al,  &lda, xh,
	xl,  &incx,  &betah, &betal,  yh,  yl, &incy );
#endif
    printf("calling single-cpu function\n");
    zhemv_(&uplo,  &n, &alphah, Ah,  &lda, xh,
	  &incx,  &betah,  yh0, &incy );

/*    for (i = 0; i < sizey; i++) {*/
/*        printf("(%e,%e),",yh[i].x,yh[i].y);*/
/*    }*/
/*    printf("\n\n");*/

/*    for (i = 0; i < sizey; i++) {*/
/*        printf("(%e,%e),",yh0[i].x,yh0[i].y);*/
/*    }*/
/*    printf("\n\n");*/

/*    printf("n:%d,incx:%d,incy:%d\n",n,incx,incy);*/
    zcheck(yh,yh0,sizey,1);



    cudaFreeHost( Ah );
    cudaFreeHost( Al );
    cudaFreeHost( xh );
    cudaFreeHost( xl );

    return 0;
}

