/* */
/* */

#define BLOCKSIZE 64
#include "gddcommon.h"

__global__ void
gddcopy_kernel( int n, double *dxh, double *dxl, int incx,
                double *dyh, double *dyl, int incy )
{
    unsigned int x = threadIdx.x+__mul24( BLOCKSIZE, blockIdx.x );
    unsigned int offset1 = __mul24( x, incx );
    unsigned int offset2 = __mul24( x, incy );

    if( x < n )
    {
        /* For Higher Part */
        *(dyh+offset2) = *(dxh+offset1);
        *(dyl+offset2) = *(dxl+offset1);
    }
}

extern "C" void
gddcopy( int *n, double *dxh, double*dxl, int *incx,
              double *dyh, double * dyl, int *incy )
{
    dim3 blocks( ( *n+BLOCKSIZE-1 )/BLOCKSIZE, 1 );

    dim3 threads( BLOCKSIZE, 1 );

    gddcopy_kernel<<< blocks, threads, 0, gddstream>>>
    ( *n,  dxh, dxl, *incx, dyh, dyl, *incy );
}

