#ifndef _BASIC_CPU_
#define _BASIC_CPU_
#ifdef __cplusplus
extern "C" {
#endif
void CalcEachArraySize( int n, int partitionNumber, int*partitions ,int *sumOfPartition);

void copyToSplitMatrix(int m,int k ,int lda,int numSplit, int *partitionM,double* Mhin,double* Mlin,double *Mhout,double*Mlout);
void copyTranspose(int k,int n ,int ldb,double* Mhin,double* Mlin,double *Mhout,double*Mlout);
void copyFromSplitMatrix(int m,int n, int ldc, int numSplit,int * partitions,double *Mhin,double*Mlin,double*Mhout,double*Mlout);


void
copyToSymmetricMatrix( int n,int lda, char*uplo, double* Mhin, double* Mlin,
                       double *Mhout,
                       double *Mlout );
void
copyFromSymmetricMatrix( int n,int lda, char*uplo, double* Mhin, double* Mlin,
                       double *Mhout,
                       double* Mlout );
void
copyFromHermitianMatrix( int n,int lda, char*uplo, cuDoubleComplex* Mhin, cuDoubleComplex* Mlin,
                       cuDoubleComplex *Mhout,
                       cuDoubleComplex* Mlout );
void
copyToHermitianMatrix( int n,int lda, char*uplo, cuDoubleComplex* Mhin, cuDoubleComplex* Mlin,
                       cuDoubleComplex *Mhout,
                       cuDoubleComplex* Mlout );

void
copyToTriangleSplitMatrix( char * uplo, char*trans,char*diag, int m, int lda,
                           int numSplit, int *partitions,
                           double* Mhin, double* Mlin, double *Mhout,
                           double*Mlout );

void
copyToBandMatrix(int m,int n,int lda, int kl,int ku, double * Mhin,double *Mlin,double*Mhout,double*Mlout);

void
copyToBandSplitMatrix( char * trans,char*diag,int m, int n, int lda, int kl, int ku,
                       int numSplit, int *partitions,
                       double* Mhin, double* Mlin, double *Mhout,
                       double*Mlout );

void
copyToSymmetricSplitMatrix( int n, int lda, char*uplo, 
		int numSplit,int *partitions,
		       double* Mhin,
                       double* Mlin,
                       double *Mhout,
                       double* Mlout );


void
copyToHermitianSplitMatrix( int n, int lda, char*uplo,
                            int numSplit, int *partitions,
                            cuDoubleComplex* Mhin,
                            cuDoubleComplex* Mlin,
                            cuDoubleComplex *Mhout,
                            cuDoubleComplex* Mlout );

void
copyToSymmetricBandSplitMatrix( int n, int kb,int lda, char*uplo,
                            int numSplit, int *partitions,
                            double* Mhin,
                            double* Mlin,
                            double *Mhout,
                            double* Mlout );
void
copyToHermitianBandSplitMatrix( int n, int kb,int lda, char*uplo,
                            int numSplit, int *partitions,
                            cuDoubleComplex* Mhin,
                            cuDoubleComplex* Mlin,
                            cuDoubleComplex *Mhout,
                            cuDoubleComplex* Mlout );


void
zcopyToBandMatrix( int m, int n, int lda, int kl, int ku, cuDoubleComplex * Mhin,
                  cuDoubleComplex *Mlin, cuDoubleComplex*Mhout,
                  cuDoubleComplex*Mlout );

void
copyFromSymmetricSplitMatrix( int n, int ldc, char*uplo ,int numSplit, int * partitions,
                     double *Mhin, double*Mlin, double*Mhout,
                     double*Mlout );


void
copyFromComplexSplitMatrix( int m, int n, int ldc, int numSplit, int * partitions,
                     cuDoubleComplex *Mhin, cuDoubleComplex*Mlin, cuDoubleComplex*Mhout,
                     cuDoubleComplex*Mlout );

void
copyToComplexSplitMatrix( int m, int k, int lda, int numSplit, int *partitions,
                   cuDoubleComplex* Mhin, cuDoubleComplex* Mlin, cuDoubleComplex *Mhout,
                   cuDoubleComplex*Mlout );

void
copyComplexTranspose( int k, int n, int ldb, cuDoubleComplex* Mhin, cuDoubleComplex* Mlin,
               cuDoubleComplex *Mhout,
               cuDoubleComplex *Mlout );

void
copyToTriangleMatrix( char * uplo,  char*diag, int m,
                      int lda,
                      double* Mhin, double* Mlin, double *Mhout,
                      double*Mlout );

void
copyFromHermitianSplitMatrix( int n, int ldc, char*uplo, int numSplit,
                              int * partitions,
                              cuDoubleComplex *Mhin, cuDoubleComplex*Mlin, cuDoubleComplex*Mhout,
                              cuDoubleComplex*Mlout );

void
copyToComplexConjugateSplitMatrix( int m, int k, int lda, int numSplit,
                          int *partitions,
                          cuDoubleComplex* Mhin, cuDoubleComplex* Mlin,
                          cuDoubleComplex *Mhout,
                          cuDoubleComplex*Mlout );

void
copyHermiteTranspose( int k, int n, int ldb, cuDoubleComplex* Mhin,
                      cuDoubleComplex* Mlin,
                      cuDoubleComplex *Mhout,
                      cuDoubleComplex *Mlout );

void
copyFromBandMatrix( int m, int n, int kl, int ku, double*Bandh,
                    double*Bandl, int lda, double*Outh,
                    double*Outl );

void
vector_copy( int N, double*xinh, double*xinl, int incxin, double*xouth,
             double*xoutl,
             int incxout );




#ifdef __cplusplus
}

template<typename T> 
void swapPointer(T **a,T**b)
{
	T * tmp = *a;
	*a = *b;
	*b = tmp;
}


#endif

#endif
