#ifndef GDDBLAS_H
#define GDDBLAS_H

#ifdef __cplusplus
extern "C"{
#endif

//vector swap: x=y,y=x
void
gddswap( int *n, double *dxh, double*dxl, int *incx,
          double *dyh, double * dyl, int *incy );


//vector add: y = x + a*y
void
gddaxpy( int *n, double *alphah, double *alphal, double *Xh,
              double *Xl, int* incx,
              double *Yh, double *Yl,
              int* incy );

//matrix multiplication: 
void
gddgemm( char*transA, char*transB, int *m, int *n, int *k,
              double *alphah, double*alphal, double *Ah, double *Al,
              int *lda,
             double * Bh, double *Bl, int *ldb, double *betah,
              double*betal, double*Ch, double*Cl,
              int *ldc );

void
gddscal( int *n, double *alphah, double *alphal, double *Xh,
              double *Xl, int* incx);

void
gddgemv( char*trans, int *m, int *n, double *alphah, double*alphal,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx,
              double *betah, double*betal, double*yh, double*yl,
              int *incy );

void
gdddot( int *n,   double *Xh, double *Xl, int* incx, double *Yh,
             double *Yl, int*incy, double * reth, double*retl );

void
gddcopy( int *n, double *dxh, double*dxl, int *incx,
              double *dyh, double * dyl, int *incy );
void
gddnrm2( int *n,   double *Xh, double *Xl, int* incx,double * reth, double*retl );

void
gddsqsum( int *n,   double *Xh, double *Xl, int* incx,  double * reth, double*retl );

void
gddasum( int *n,   double *Xh, double *Xl, int* incx,  double * reth,
              double*retl );

int
gddidamax( int *n,   double *Xh, double *Xl, int* incx );

void
gddzdotc( int *n,   cuDoubleComplex *Xh, cuDoubleComplex *Xl, int* incx, cuDoubleComplex *Yh,
             cuDoubleComplex *Yl, int*incy, cuDoubleComplex * reth, cuDoubleComplex*retl );


void
gddzdotu( int *n,   cuDoubleComplex *Xh, cuDoubleComplex *Xl, int* incx, cuDoubleComplex *Yh,
             cuDoubleComplex *Yl, int*incy, cuDoubleComplex * reth, cuDoubleComplex*retl );

void
gddrot( int *n, double *Xh,
             double *Xl, int* incx,
             double *Yh, double *Yl,
             int* incy, double *ch, double*cl,
             double*sh, double*sl );

void
gddrotm( int *n, double *Xh,
             double *Xl, int* incx,
             double *Yh, double *Yl,
             int* incy, 
             double*paramh, double*paraml );


void
gddger( int* m, int* n, double *alphah, double*alphal,
               double * xh, double *xl,
               int* incx,
               double*yh, double*yl,
               int* incy,
               double* Ah, double *Al, int* lda  );


void
gddsyr2( char* uplo, int* n, double *alphah, double*alphal,
              double * xh, double *xl,
              int* incx,
              double*yh, double*yl,
              int* incy,
              double* Ah, double *Al, int* lda  );

 void
gddsyr( char* uplo, int* n, double *alphah, double*alphal,
              double * xh, double *xl,
              int* incx,
              double* Ah, double *Al, int* lda  );

 void
gddzgeru( int* m, int* n, cuDoubleComplex *alphah, cuDoubleComplex*alphal,
               cuDoubleComplex * xh, cuDoubleComplex *xl,
               int* incx,
               cuDoubleComplex*yh, cuDoubleComplex*yl,
               int* incy,
               cuDoubleComplex* Ah, cuDoubleComplex *Al, int* lda  );
 void
gddzgerc( int* m, int* n, cuDoubleComplex *alphah, cuDoubleComplex*alphal,
               cuDoubleComplex * xh, cuDoubleComplex *xl,
               int* incx,
               cuDoubleComplex*yh, cuDoubleComplex*yl,
               int* incy,
               cuDoubleComplex* Ah, cuDoubleComplex *Al, int* lda  );

void
gddzher2( char* uplo, int* n, cuDoubleComplex *alphah, cuDoubleComplex*alphal,
              cuDoubleComplex * xh, cuDoubleComplex *xl,
              int* incx,
              cuDoubleComplex*yh, cuDoubleComplex*yl,
              int* incy,
              cuDoubleComplex* Ah, cuDoubleComplex *Al, int* lda  );

void
gddzher( char* uplo, int* n, double *alphah,
              double*alphal,
              cuDoubleComplex * xh, cuDoubleComplex *xl,
              int* incx,
              cuDoubleComplex* Ah, cuDoubleComplex *Al,
              int* lda  );
void
gddgbmv( char*trans, int *m, int *n, int*kl, int*ku, double *alphah,
              double*alphal,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx,
              double *betah, double*betal, double*yh, double*yl,
              int *incy );


void
gddtbmv(char*uplo, char*trans, char*diag, int *n,int *k,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx  );
void
gddsymv( char*uplo, int *n, double *alphah, double*alphal,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx,
              double *betah, double*betal, double*yh, double*yl,
              int *incy );
void
gddzhemv( char*uplo, int *n, cuDoubleComplex *alphah, cuDoubleComplex*alphal,
              cuDoubleComplex *Ah, cuDoubleComplex *Al, int *lda, cuDoubleComplex * xh, cuDoubleComplex *xl,
              int *incx,
              cuDoubleComplex *betah, cuDoubleComplex*betal, cuDoubleComplex*yh, cuDoubleComplex*yl,
              int *incy );

void
gddzgemv( char*trans, int *m, int *n, cuDoubleComplex *alphah, cuDoubleComplex*alphal,
              cuDoubleComplex *Ah, cuDoubleComplex *Al, int *lda, cuDoubleComplex * xh, cuDoubleComplex *xl,
              int *incx,
              cuDoubleComplex *betah, cuDoubleComplex*betal, cuDoubleComplex*yh, cuDoubleComplex*yl,
              int *incy );

void
gddsymv( char*uplo, int *n, double *alphah, double*alphal,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx,
              double *betah, double*betal, double*yh, double*yl,
              int *incy );
void gddtrsminner_
( char side, char uplo, char tran, char diag, int M, int N, 
  double* alphah, double* alphal,
  double Ah[],double Al[],
  int lda,
  double bh[], double bl[],
  int ldb);

void gddtrsm
( char *side, char *uplo, char *tran, char *diag, int *M, int *N, 
  double* alphah, double* alphal,
  double Ah[],double Al[],
  int *lda,
  double bh[], double bl[],
  int *ldb);

void
gddtrsv( char *uplo, char *tran, char *diag, int *N,
              double Ah[], double Al[],
              int *lda,
              double xh[], double xl[],
              int *incx );

void
gddtbsv( char*uplo, char*trans, char*diag, int *n,int *k,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx );

void gddzgemm
( char* transA, char* transB,
  int* m, int* n, int* k,
  cuDoubleComplex* alphah, cuDoubleComplex* alphal,
  cuDoubleComplex Ah[], cuDoubleComplex Al[], int* lda,
  cuDoubleComplex Bh[], cuDoubleComplex Bl[], int* ldb,
  cuDoubleComplex* betah, cuDoubleComplex* betal,
  cuDoubleComplex Ch[], cuDoubleComplex Cl[], int* ldc );




#ifdef __cplusplus
}
#endif

#endif
