#ifndef GDDBLAS_CPU_H
#define GDDBLAS_CPU_H
#ifdef __cplusplus
extern "C" {
#endif

int
gddswap_host_( int *n, double *dxh, double*dxl, int *incx,
              double *dyh, double * dyl, int *incy );

int
gddswap_host_multigpu_( int *n, double *dxh, double*dxl, int *incx,
              double *dyh, double * dyl, int *incy );


int
gddaxpy_host_( int *n, double *alphah, double *alphal, double *xh,
              double *xl, int*incx,
              double *yh, double *yl,
              int *incy  );


int
gddaxpy_host_multigpu_( int *n, double *alphah, double *alphal, double *xh,
                       double *xl, int*incx,
                       double *yh, double *yl,
                       int *incy  );

void
gddasum_host_( int *n,   double *Xh, double *Xl, int* incx,  double * reth,
              double*retl );

void
gddasum_host_multigpu_( int *n,   double *Xh, double *Xl, int* incx,  double * reth,
              double*retl );

int
gddgemv_host_( char*trans, int *m, int *n, double *alphah, double*alphal,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx,
              double *betah, double*betal, double*yh, double*yl,
              int *incy  );
int
gddgemv_host_multigpu_( char*trans, int *m, int *n, double *alphah, double*alphal,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx,
              double *betah, double*betal, double*yh, double*yl,
              int *incy  );



int
gddgemm_host_( char*transA, char*transB, int *m, int*n, int*k,
              double *alphah, double *alphal, double *Ah,
              double *Al, int*lda,
              double *Bh, double *Bl,
              int *ldb, double *betah, double *betal, double *Ch,
              double *Cl,
              int*ldc );
int
gddgemm_host_multigpu_( char*transA, char*transB, int *m, int*n, int*k,
              double *alphah, double *alphal, double *Ah,
              double *Al, int*lda,
              double *Bh, double *Bl,
              int *ldb, double *betah, double *betal, double *Ch,
              double *Cl,
              int*ldc );
int
gddscal_host_( int *n, double *alphah, double *alphal, double *xh,double *xl, int*incx );

int
gddscal_host_multigpu_( int *n, double *alphah, double *alphal, double *xh,double *xl, int*incx );

int
gddcopy_host_( int *n, double *dxh, double*dxl, int *incx,
              double *dyh, double * dyl, int *incy );


int
gddcopy_host_multigpu_( int *n, double *dxh, double*dxl, int *incx,
              double *dyh, double * dyl, int *incy );

int
gdddot_host_( int *n, double *xh,double *xl, int*incx,double *yh, double *yl,int *incy  ,double *reth,double*retl);

int
gdddot_host_multigpu_( int *n, double *xh,double *xl, int*incx,double *yh, double *yl,int *incy  ,double *reth,double*retl);

int 
gddnrm2_host_( int *n, double *xh,double *xl, int*incx,double *reth,double*retl);

int 
gddnrm2_host_multigpu_( int *n, double *xh,double *xl, int*incx,double *reth,double*retl);

int
gddzdotc_host_( int *n, cuDoubleComplex *xh,cuDoubleComplex *xl, int*incx,cuDoubleComplex *yh, cuDoubleComplex *yl,int *incy  ,cuDoubleComplex *reth,cuDoubleComplex*retl);

int
gddzdotc_host_multigpu_( int *n, cuDoubleComplex *xh,cuDoubleComplex *xl, int*incx,cuDoubleComplex *yh, cuDoubleComplex *yl,int *incy  ,cuDoubleComplex *reth,cuDoubleComplex*retl);

int
gddgbmv_host_( char*trans, int*kl, int*ku, int *m, int *n, double *alphah,
              double*alphal,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx,
              double *betah, double*betal, double*yh, double*yl,
              int *incy  );

int
gddgbmv_host_multigpu_( char*trans, int *m, int *n, int*kl, int*ku, double *alphah,
              double*alphal,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx,
              double *betah, double*betal, double*yh, double*yl,
              int *incy  );

int
gddsymv_host_(char*uplo, int *n,double *alphah,double *alphal,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx ,double *betah,double*betal,double * yh, double *yl,
              int *incy );

int
gddsymv_host_multigpu_(char*uplo, int *n,double *alphah,double *alphal,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx ,double *betah,double*betal,double * yh, double *yl,
              int *incy );

int
gddtrmv_host_multigpu_( char*uplo, char*trans, char*diag, int *n,
                       double *Ah, double *Al, int *lda, double * xh,
                       double *xl,
                       int *incx   );


int
gddtrmv_host_( char*uplo, char*trans, char*diag, int *n,
                       double *Ah, double *Al, int *lda, double * xh,
                       double *xl,
                       int *incx   );


int gddtrsm_host_
( char* side, char* uplo, char* transA, char* diag,
  int* m, int* n,
  double* alphah, double* alphal,
  double* Ah, double* Al, int* lda,
  double* Bh, double* Bl, int* ldb );

int
gddtrsm_host_multigpu_( char* side, char* uplo, char* transA, char* diag,
                       int* m, int* n,
                       double* alphah, double* alphal,
                       double* Ah, double* Al, int* lda,
                       double* Bh, double* Bl, int* ldb );
int
gddtrsv_host_multigpu_(char*uplo, char*trans, char*diag, int *n,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx  );
int
gddtrsv_host_(char*uplo, char*trans, char*diag, int *n,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx  );

int
gddsyr_host_multigpu_( char* uplo, int *n, double *alphah, double*alphal,
                      double * xh, double *xl,
                      int *incx,
                      double *Ah, double *Al,
                      int *lda );
int
gddsyr_host_( char* uplo, int *n, double *alphah, double*alphal,
                      double * xh, double *xl,
                      int *incx,
                      double *Ah, double *Al,
                      int *lda );
int
gddsyr2_host_multigpu_( char* uplo, int *n, double *alphah, double*alphal,
                      double * xh, double *xl,
                      int *incx,
                      double*yh, double*yl,
                      int *incy,
                      double *Ah, double *Al,
                      int *lda );
int
gddsyr2_host_( char* uplo, int *n, double *alphah, double*alphal,
                      double * xh, double *xl,
                      int *incx,
                      double*yh, double*yl,
                      int *incy,
                      double *Ah, double *Al,
                      int *lda );

int
gddsymm_host_multigpu_( char* side, char* uplo,
                       int* m, int* n,
                       double* alphah, double* alphal,
                       double* Ah, double* Al, int* lda,
                       double* Bh, double* Bl, int* ldb,
                       double* betah, double* betal,
                       double* Ch, double* Cl, int* ldc );
int
gddsymm_host_( char* side, char* uplo,
                       int* m, int* n,
                       double* alphah, double* alphal,
                       double* Ah, double* Al, int* lda,
                       double* Bh, double* Bl, int* ldb,
                       double* betah, double* betal,
                       double* Ch, double* Cl, int* ldc );


int
gddsyr2k_host_multigpu_( char* uplo, char* trans,
                        int* n, int* k,
                        double* alphah, double* alphal,
                        double* Ah, double* Al, int* lda,
                        double* Bh, double* Bl, int* ldb,
                        double* betah, double* betal,
                        double* Ch, double* Cl, int* ldc );
int
gddsyr2k_host_( char* uplo, char* trans,
                        int* n, int* k,
                        double* alphah, double* alphal,
                        double* Ah, double* Al, int* lda,
                        double* Bh, double* Bl, int* ldb,
                        double* betah, double* betal,
                        double* Ch, double* Cl, int* ldc );

int
gddidamax_host_multigpu_( int *n,  double *xh, double *xl, int*incx);

int
gddidamax_host_( int *n,  double *xh, double *xl, int*incx);


int
gddzdotu_host_multigpu_( int *n,  cuDoubleComplex *xh, cuDoubleComplex *xl, int*incx,
                      cuDoubleComplex *yh, cuDoubleComplex *yl, int *incy  ,cuDoubleComplex* reth,cuDoubleComplex*retl);

int
gddzdotu_host_( int *n,  cuDoubleComplex *xh, cuDoubleComplex *xl, int*incx,
                      cuDoubleComplex *yh, cuDoubleComplex *yl, int *incy  ,cuDoubleComplex* reth,cuDoubleComplex*retl);

int
gddrot_host_multigpu_( int *n, double *xh,
                       double *xl, int*incx,
                       double *yh, double *yl,
                       int *incy  ,
             double*ch, double*cl, double*sh,
             double*sl );
int
gddrot_( int *n, double *xh,
                       double *xl, int*incx,
                       double *yh, double *yl,
                       int *incy  ,
             double*ch, double*cl, double*sh,
             double*sl );

void
gddrotg_host_( double*dah, double* dal, double*dbh, double*dbl,
              double*ch, double*cl, double*sh, double*sl );

int
gddrotm_host_multigpu_( int *n, double *xh,
                       double *xl, int*incx,
                       double *yh, double *yl,
                       int *incy,
                       double*paramh, double*paraml );

int
gddrotm_host_( int *n, double *xh,
                       double *xl, int*incx,
                       double *yh, double *yl,
                       int *incy,
                       double*paramh, double*paraml );
 int
gddrotmg_host_(  double *dd1h, double*dd1l,
                double *dd2h, double*dd2l,
                double *dx1h, double*dx1l,
                double *dy1h, double*dy1l,
                double *dparamh, double*dparaml );

int
gddsbmv_host_multigpu_( char*uplo, int *n,int *kb,double *alphah,double *alphal,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx ,double *betah,double*betal,double * yh, double *yl,
              int *incy  );
int
gddsbmv_host_( char*uplo, int *n,int *kb,double *alphah,double *alphal,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx ,double *betah,double*betal,double * yh, double *yl,
              int *incy  );


int
gddtbmv_host_multigpu_( char*uplo, char*trans, char*diag, int *n,int *k,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx );
int
gddtbmv_host_( char*uplo, char*trans, char*diag, int *n,int *k,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx );

int
gddtbsv_host_multigpu_( char*uplo, char*trans, char*diag, int *n, int *k,
                       double *Ah, double *Al, int *lda, double * xh,
                       double *xl,
                       int *incx  );

int
gddtbsv_host_( char*uplo, char*trans, char*diag, int *n, int *k,
                       double *Ah, double *Al, int *lda, double * xh,
                       double *xl,
                       int *incx  );

int
gddger_host_multigpu_( int *m, int *n, double *alphah, double*alphal,
                      double * xh, double *xl,
                      int *incx,
                      double*yh, double*yl,
                      int *incy,
                      double *Ah, double *Al,
                      int *lda );

int
gddger_host_( int *m, int *n, double *alphah, double*alphal,
                      double * xh, double *xl,
                      int *incx,
                      double*yh, double*yl,
                      int *incy,
                      double *Ah, double *Al,
                      int *lda );

int
gddzgeru_host_multigpu_( int *m, int *n, cuDoubleComplex *alphah, cuDoubleComplex*alphal,
                      cuDoubleComplex * xh, cuDoubleComplex *xl,
                      int *incx,
                      cuDoubleComplex*yh, cuDoubleComplex*yl,
                      int *incy,
                      cuDoubleComplex *Ah, cuDoubleComplex *Al,
                      int *lda );

int
gddzgeru_host_( int *m, int *n, cuDoubleComplex *alphah, cuDoubleComplex*alphal,
                      cuDoubleComplex * xh, cuDoubleComplex *xl,
                      int *incx,
                      cuDoubleComplex*yh, cuDoubleComplex*yl,
                      int *incy,
                      cuDoubleComplex *Ah, cuDoubleComplex *Al,
                      int *lda );

int
gddzgerc_host_multigpu_( int *m, int *n, cuDoubleComplex *alphah, cuDoubleComplex*alphal,
                      cuDoubleComplex * xh, cuDoubleComplex *xl,
                      int *incx,
                      cuDoubleComplex*yh, cuDoubleComplex*yl,
                      int *incy,
                      cuDoubleComplex *Ah, cuDoubleComplex *Al,
                      int *lda );

int
gddzgerc_host_( int *m, int *n, cuDoubleComplex *alphah, cuDoubleComplex*alphal,
                      cuDoubleComplex * xh, cuDoubleComplex *xl,
                      int *incx,
                      cuDoubleComplex*yh, cuDoubleComplex*yl,
                      int *incy,
                      cuDoubleComplex *Ah, cuDoubleComplex *Al,
                      int *lda );

int
gddzhemv_host_multigpu_( char*uplo, int *n, cuDoubleComplex *alphah,
                        cuDoubleComplex *alphal,
                        cuDoubleComplex *Ah, cuDoubleComplex *Al, int *lda,
                        cuDoubleComplex * xh, cuDoubleComplex *xl,
                        int *incx, cuDoubleComplex *betah,
                        cuDoubleComplex*betal, cuDoubleComplex * yh,
                        cuDoubleComplex *yl,
                        int *incy  );

int
gddzhemv_host_( char*uplo, int *n, cuDoubleComplex *alphah,
                        cuDoubleComplex *alphal,
                        cuDoubleComplex *Ah, cuDoubleComplex *Al, int *lda,
                        cuDoubleComplex * xh, cuDoubleComplex *xl,
                        int *incx, cuDoubleComplex *betah,
                        cuDoubleComplex*betal, cuDoubleComplex * yh,
                        cuDoubleComplex *yl,
                        int *incy  );

int
gddzhbmv_host_multigpu_( char*uplo, int *n,int *kb,cuDoubleComplex *alphah,cuDoubleComplex *alphal,
              cuDoubleComplex *Ah, cuDoubleComplex *Al, int *lda, cuDoubleComplex * xh, cuDoubleComplex *xl,
              int *incx ,cuDoubleComplex *betah,cuDoubleComplex*betal,cuDoubleComplex * yh, cuDoubleComplex *yl,
              int *incy  );
int
gddzhbmv_host_( char*uplo, int *n,int *kb,cuDoubleComplex *alphah,cuDoubleComplex *alphal,
              cuDoubleComplex *Ah, cuDoubleComplex *Al, int *lda, cuDoubleComplex * xh, cuDoubleComplex *xl,
              int *incx ,cuDoubleComplex *betah,cuDoubleComplex*betal,cuDoubleComplex * yh, cuDoubleComplex *yl,
              int *incy  );

int
gddzher_host_multigpu_( char* uplo, int *n, double *alphah, double*alphal,
                      cuDoubleComplex * xh, cuDoubleComplex *xl,
                      int *incx,
                      cuDoubleComplex *Ah, cuDoubleComplex *Al,
                      int *lda );
int
gddzher_host_( char* uplo, int *n, double *alphah, double*alphal,
                      cuDoubleComplex * xh, cuDoubleComplex *xl,
                      int *incx,
                      cuDoubleComplex *Ah, cuDoubleComplex *Al,
                      int *lda );

int
gddzher2_host_multigpu_( char* uplo, int *n, cuDoubleComplex *alphah, cuDoubleComplex*alphal,
                      cuDoubleComplex * xh, cuDoubleComplex *xl,
                      int *incx,
                      cuDoubleComplex*yh, cuDoubleComplex*yl,
                      int *incy,
                      cuDoubleComplex *Ah, cuDoubleComplex *Al,
                      int *lda );
int
gddzher2_host_( char* uplo, int *n, cuDoubleComplex *alphah, cuDoubleComplex*alphal,
                      cuDoubleComplex * xh, cuDoubleComplex *xl,
                      int *incx,
                      cuDoubleComplex*yh, cuDoubleComplex*yl,
                      int *incy,
                      cuDoubleComplex *Ah, cuDoubleComplex *Al,
                      int *lda );

int
gddsyrk_host_multigpu_( char* uplo, char* trans,
                        int* n, int* k,
                        double* alphah, double* alphal,
                        double* Ah, double* Al, int* lda,
                        double* betah, double* betal,
                        double* Ch, double* Cl, int* ldc );

int
gddsyrk_host_( char* uplo, char* trans,
                        int* n, int* k,
                        double* alphah, double* alphal,
                        double* Ah, double* Al, int* lda,
                        double* betah, double* betal,
                        double* Ch, double* Cl, int* ldc );

int
gddtrmm_host_multigpu_( char* side, char* uplo,
                       char*trans, char*diag,
                       int* m, int* n,
                       double* alphah, double* alphal,
                       double* Ah, double* Al, int* lda,
                       double* Bh, double* Bl, int* ldb );

int
gddtrmm_host_( char* side, char* uplo,
                       char*trans, char*diag,
                       int* m, int* n,
                       double* alphah, double* alphal,
                       double* Ah, double* Al, int* lda,
                       double* Bh, double* Bl, int* ldb );

int
gddtrmm_host_multigpu_( char* side, char* uplo,
                       char*trans, char*diag,
                       int* m, int* n,
                       double* alphah, double* alphal,
                       double* Ah, double* Al, int* lda,
                       double* Bh, double* Bl, int* ldb );

int
gddtrmm_host_( char* side, char* uplo,
                       char*trans, char*diag,
                       int* m, int* n,
                       double* alphah, double* alphal,
                       double* Ah, double* Al, int* lda,
                       double* Bh, double* Bl, int* ldb );

int
gddzherk_host_multigpu_( char* uplo, char* trans,
                        int* n, int* k,
                        double* alphah, double* alphal,
                        cuDoubleComplex* Ah, cuDoubleComplex* Al, int* lda,
                        double* betah, double* betal,
                        cuDoubleComplex* Ch, cuDoubleComplex* Cl, int* ldc );

int
gddzherk_host_( char* uplo, char* trans,
                        int* n, int* k,
                        double* alphah, double* alphal,
                        cuDoubleComplex* Ah, cuDoubleComplex* Al, int* lda,
                        double* betah, double* betal,
                        cuDoubleComplex* Ch, cuDoubleComplex* Cl, int* ldc );

int
gddzher2k_host_multigpu_back_( char* uplo, char* trans,
                        int* n, int* k,
                        cuDoubleComplex* alphah, cuDoubleComplex* alphal,
                        cuDoubleComplex* Ah, cuDoubleComplex* Al, int* lda,
                        cuDoubleComplex* Bh, cuDoubleComplex* Bl, int* ldb,
                        double* betah, double* betal,
                        cuDoubleComplex* Ch, cuDoubleComplex* Cl, int* ldc );



#ifdef __cplusplus
}
#endif


#endif
