#ifndef _GDD_COMMON_H_
#define _GDD_COMMON_H_

#include <stdio.h>
#include <cuda.h>
#include <cuda_runtime_api.h>
#include <cublas.h>
#include <math.h>
#include <string.h>
#include <ctype.h>

/***************************************************************************//**
 *  Global utilities
 **/
#ifndef max
#define max(a, b) ((a) > (b) ? (a) : (b))
#endif
#ifndef min
#define min(a, b) ((a) < (b) ? (a) : (b))
#endif
#ifndef roundup
#define roundup(a, b) (b <= 0) ? (a) : (((a) + (b)-1) & ~((b)-1))
#endif

/** ****************************************************************************
 *  Define magma streams
 */

extern cudaStream_t gddstream;

cublasStatus_t gddSetKernelStream( cudaStream_t stream );
cublasStatus_t gddGetKernelStream( cudaStream_t *stream );

#include "gddblas.h"
#include "config.h"
#include "basic_algebra_host.h"
#include "gdd_basic_inline.h"

#endif
