      program speedcheck
      implicit none

      real(8),allocatable :: ah(:,:),al(:,:)
      real(8),allocatable :: xh(:),xl(:)
      real(8),allocatable :: yh(:),yl(:)
      real(8),allocatable :: zh(:),zl(:)
      integer n,k,kl,ku
      integer incx,incy
      integer lda
      integer matsize
      real(8) :: alphah,alphal,betah,betal
      character :: trans = 'n'

      real(8) :: getsec
      real(8) :: tini, tdiff_cpu, tdiff_gpu

      integer,parameter :: fochk = 21

      incx = 1
      incy = 1

      matsize = 2

      open(fochk,file='speedcheck_gbmv.csv',action='write')
      write(fochk,'(a)')'matsize,CPU,GPU'

!      do while ( matsize <= 1024  )
      do while ( matsize <= 2**14  )
      n = matsize 

      kl = matsize/2 - 1
      ku = matsize/2 - 1

      lda = matsize - 1

      allocate(ah(n,n),al(n,n),xh(n),xl(n),yh(n),yl(n),zh(n),zl(n))

      call realgen1mat(n,n,ah,al)
      call realgen1mat(1,1,alphah,alphal)
      call realgen1mat(1,1,betah,betal)
      call realgen1mat(1,n,xh,xl)
      call realgen1mat(1,n,yh,yl)
      call realgen1mat(1,n,zh,zl)

      zh = yh
      zl = yl

      call gettimeofday_sec(tini)
      call ddgbmv(trans,n,n,kl,ku,alphah,alphal,ah,al,lda,
     &            xh,xl,incx,betah,betal,yh,yl,incy)
      tdiff_cpu = getsec(tini)
      
      call gettimeofday_sec(tini)
      call gddgbmv_host(trans,n,n,kl,ku,alphah,alphal,ah,al,lda,
     &                 xh,xl,incx,betah,betal,zh,zl,incy)
      tdiff_gpu = getsec(tini)

      write(*,    1000) matsize,tdiff_cpu,tdiff_gpu
      write(fochk,1000) matsize,tdiff_cpu,tdiff_gpu

      deallocate(ah,al,xh,xl,yh,yl,zh,zl)

      matsize = matsize*2
      end do

      close(fochk)

 1000 format(i8,',',1pe16.8,',',1pe16.8)
      stop
      end program
