      program speedcheck
      implicit none

      real(8),allocatable :: ah(:,:),al(:,:)
      real(8),allocatable :: bh(:,:),bl(:,:)
      real(8),allocatable :: ch(:,:),cl(:,:)
      real(8),allocatable :: dh(:,:),dl(:,:)
      integer m,n,k
      integer matsize
      real(8) :: alphah,alphal,betah,betal
      character :: transA = 'N',transB = 'N'

      real(8) :: getsec
      real(8) :: tini, tdiff_cpu, tdiff_gpu

      integer,parameter :: fochk = 21


      matsize = 1

      open(fochk,file='speedcheck_gemm.csv',action='write')
      write(fochk,'(a)')'matsize,CPU,GPU'

      do while ( matsize <= 1024  )
      m = matsize 
      n = matsize 
      k = matsize 

      allocate(ah(m,k),al(m,k),bh(k,n),bl(k,n),ch(m,n),cl(m,n),
     &dh(m,n),dl(m,n))

      call realgen1mat(m,k,ah,al)
      call realgen1mat(k,n,bh,bl)

      call realgen1mat(1,1,alphah,alphal)
      call realgen1mat(1,1,betah,betal)

      call realgen1mat(m,n,ch,cl)

      dh = ch
      dl = cl

      call gettimeofday_sec(tini)

      call ddgemm(transA,transB,m,n,k,alphah,alphal,Ah,Al,m,
     &Bh,Bl,k,betah,betal,Ch,Cl,m)

      tdiff_cpu = getsec(tini)
      
      call gettimeofday_sec(tini)

      call gddgemm_host(transA,transB,m,n,k,alphah,alphal,Ah,Al,m,
     &Bh,Bl,k,betah,betal,Dh,Dl,m)

      tdiff_gpu = getsec(tini)

      write(*,    1000) matsize,tdiff_cpu,tdiff_gpu
      write(fochk,1000) matsize,tdiff_cpu,tdiff_gpu

      deallocate(ah,al,bh,bl,ch,cl,dh,dl)

      matsize = matsize*2
      end do

      close(fochk)

 1000 format(i8,',',1pe16.8,',',1pe16.8)
      stop
      end program
