      program speedcheck
      implicit none

      real(8),allocatable :: ah(:,:),al(:,:)
      real(8),allocatable :: xh(:),xl(:)
      integer m,n,k
      integer incx,incy
      integer lda,ldb,ldc
      integer matsize
      real(8) :: alphah,alphal,betah,betal,dah,dal,ddh,ddl
      character :: trans = 'N'
      character :: side = 'l'
      character :: uplo = 'l'

      real(8) :: getsec
      real(8) :: tini, tdiff_cpu, tdiff_gpu

      integer,parameter :: fochk = 21

      incx = 1
      incy = 1

      matsize = 1

      open(fochk,file='speedcheck_nrm2.csv',action='write')
      write(fochk,'(a)')'matsize,CPU,GPU'

!      do while ( matsize <= 1024  )
      do while ( matsize <= 2**25  )
      n = matsize 

      lda = matsize
      ldb = matsize
      ldc = matsize

      allocate(xh(n),xl(n))

      call realgen1mat(1,1,dah,dal)
      call realgen1mat(1,n,xh,xl)

      call gettimeofday_sec(tini)

      call ddnrm2(n,xh,xl,incx,ddh,ddl)

      tdiff_cpu = getsec(tini)
      
      call gettimeofday_sec(tini)

      call gddnrm2_host(n,xh,xl,incx,ddh,ddl)

      tdiff_gpu = getsec(tini)

      write(*,    1000) matsize,tdiff_cpu,tdiff_gpu
      write(fochk,1000) matsize,tdiff_cpu,tdiff_gpu

      deallocate(xh,xl)

      matsize = matsize*2
      end do

      close(fochk)

 1000 format(i10,',',1pe16.8,',',1pe16.8)
      stop
      end program
