      program speedcheck
      implicit none

      real(8),allocatable :: ah(:,:),al(:,:)
      real(8),allocatable :: dxh(:),dxl(:)
      real(8),allocatable :: dyh(:),dyl(:)
      real(8),allocatable :: dzh(:),dzl(:)
      integer m,n,k
      integer incx,incy
      integer lda,ldb,ldc
      integer matsize
      real(8) :: alphah,alphal,betah,betal,
     &           dah,dal,dbh,dbl,dch,dcl,ddh,ddl,ch,cl,sh,sl
      character :: trans = 'N'
      character :: side = 'l'
      character :: uplo = 'l'

      real(8) :: getsec
      real(8) :: tini, tdiff_cpu, tdiff_gpu

      integer,parameter :: fochk = 21

      incx = 1
      incy = 1

      matsize = 1

      open(fochk,file='speedcheck_rotg.csv',action='write')
      write(fochk,'(a)')'matsize,CPU,GPU'

!      do while ( matsize <= 1024  )
      do while ( matsize <= 2**25  )
      n = matsize 

      lda = matsize
      ldb = matsize
      ldc = matsize

      allocate(dxh(n),dxl(n),dyh(n),dyl(n),dzh(n),dzl(n))

      call realgen1mat(1,1,dah,dal)
      call realgen1mat(1,1,dbh,dbl)
      call realgen1mat(1,1,dch,dcl)
      call realgen1mat(1,1,ddh,ddl)
      call realgen1mat(1,1,ch,cl)
      call realgen1mat(1,1,sh,sl)

      dch = dah
      dcl = dal
      ddh = dbh
      ddl = dbl

      call gettimeofday_sec(tini)

      call ddrotg(dah,dal,dbh,dbl,ch,cl,sh,sl)

      tdiff_cpu = getsec(tini)
      
      call gettimeofday_sec(tini)

      call gddrotg_host(dch,dcl,ddh,ddl,ch,cl,sh,sl)

      tdiff_gpu = getsec(tini)

      write(*,    1000) matsize,tdiff_cpu,tdiff_gpu
      write(fochk,1000) matsize,tdiff_cpu,tdiff_gpu

      deallocate(dxh,dxl,dyh,dyl,dzh,dzl)

      matsize = matsize*2
      end do

      close(fochk)

 1000 format(i10,',',1pe16.8,',',1pe16.8)
      stop
      end program
