      program speedcheck
      implicit none

      real(8),allocatable :: ah(:,:),al(:,:)
      real(8),allocatable :: dxh(:),dxl(:)
      real(8),allocatable :: dyh(:),dyl(:)
      real(8),allocatable :: dzh(:),dzl(:)
      real(8),allocatable :: dwh(:),dwl(:)
      integer m,n,k
      integer incx,incy
      integer lda,ldb,ldc
      integer matsize
      real(8) :: dd1h,dd1l,dd2h,dd2l,dx1h,dx1l,dy1h,dy1l
      real(8) :: dd3h,dd3l,dd4h,dd4l,dx2h,dx2l
      real(8) :: dparamh(5),dparaml(5),eparamh(5),eparaml(5)
      character :: trans = 'N'
      character :: side = 'l'
      character :: uplo = 'l'

      real(8) :: getsec
      real(8) :: tini, tdiff_cpu, tdiff_gpu

      integer,parameter :: fochk = 21

      incx = 1
      incy = 1

      matsize = 1

      open(fochk,file='speedcheck_rotmg.csv',action='write')
      write(fochk,'(a)')'matsize,CPU,GPU'

!      do while ( matsize <= 1024  )
      do while ( matsize <= 2**25  )
      n = matsize 

      lda = matsize
      ldb = matsize
      ldc = matsize

      allocate(dxh(n),dxl(n),dyh(n),dyl(n),dzh(n),dzl(n),dwh(n),dwl(n))

      call realgen1mat(1,1,dd1h,dd1l)
      call realgen1mat(1,1,dd2h,dd2l)
      call realgen1mat(1,1,dx1h,dx1l)

      call realgen1mat(1,5,dparamh,dparaml)

      dd3h = dd1h
      dd3l = dd1l
      dd4h = dd2h
      dd4l = dd2l
      dx2h = dx1h
      dx2l = dx1l

      eparamh = dparamh
      eparaml = dparaml

      call gettimeofday_sec(tini)

      call ddrotmg(dd1h,dd1l,dd2h,dd2l,dx1h,dx1l,dy1h,dy1l,
     &             dparamh,dparaml)

      tdiff_cpu = getsec(tini)
      
      call gettimeofday_sec(tini)

      call gddrotmg_host(dd3h,dd3l,dd4h,dd4l,dx2h,dx2l,dy1h,dy1l,
     &                  eparamh,eparaml)

      tdiff_gpu = getsec(tini)

      write(*,    1000) matsize,tdiff_cpu,tdiff_gpu
      write(fochk,1000) matsize,tdiff_cpu,tdiff_gpu

      deallocate(dxh,dxl,dyh,dyl,dzh,dzl,dwh,dwl)

      matsize = matsize*2
      end do

      close(fochk)

 1000 format(i10,',',1pe16.8,',',1pe16.8)
      stop
      end program
