      program speedcheck
      implicit none

      real(8),allocatable :: ah(:,:),al(:,:)
      real(8),allocatable :: bh(:,:),bl(:,:)
      real(8),allocatable :: ch(:,:),cl(:,:)
      real(8),allocatable :: dh(:,:),dl(:,:)
      integer m,n,k
      integer lda,ldb,ldc
      integer matsize
      real(8) :: alphah,alphal,betah,betal
      character :: transA = 'N',transB = 'N'
      character :: side = 'l'
      character :: uplo = 'l'

      real(8) :: getsec
      real(8) :: tini, tdiff_cpu, tdiff_gpu

      integer,parameter :: fochk = 21

      matsize = 1

      open(fochk,file='speedcheck_symm.csv',action='write')
      write(fochk,'(a)')'matsize,CPU,GPU'

      do while ( matsize <= 1024  )
      n = matsize 

      lda = matsize
      ldb = matsize
      ldc = matsize

      allocate(ah(n,n),al(n,n),bh(n,n),bl(n,n),ch(n,n),cl(n,n),
     &         dh(n,n),dl(n,n))

      call realgen1mat(n,n,ah,al)
      call realgen1mat(n,n,bh,bl)

      call realgen1mat(1,1,alphah,alphal)
      call realgen1mat(1,1,betah,betal)

      call realgen1mat(n,n,ch,cl)

      dh = ch
      dl = cl

      call gettimeofday_sec(tini)

      call ddsymm(side,uplo,n,n,alphah,alphal,ah,al,
     &            lda,bh,bl,ldb,betah,betal,ch,cl,ldc)

      tdiff_cpu = getsec(tini)
      
      call gettimeofday_sec(tini)

      call gddsymm_host(side,uplo,n,n,alphah,alphal,ah,al,
     &                 lda,bh,bl,ldb,betah,betal,dh,dl,ldc)

      tdiff_gpu = getsec(tini)

      write(*,    1000) matsize,tdiff_cpu,tdiff_gpu
      write(fochk,1000) matsize,tdiff_cpu,tdiff_gpu

      deallocate(ah,al,bh,bl,ch,cl,dh,dl)

      matsize = matsize*2
      end do

      close(fochk)

 1000 format(i8,',',1pe16.8,',',1pe16.8)
      stop
      end program
