      program speedcheck
      implicit none

      double complex,allocatable :: zxh(:),zxl(:)
      double complex,allocatable :: zyh(:),zyl(:)
      integer m,n,k
      integer incx,incy
      integer lda,ldb,ldc
      integer matsize
      double complex :: zzh,zzl
      character :: trans = 'N'
      character :: side = 'l'
      character :: uplo = 'l'

      real(8) :: getsec
      real(8) :: tini, tdiff_cpu, tdiff_gpu

      integer,parameter :: fochk = 21

      incx = 1
      incy = 1

      matsize = 1

      open(fochk,file='speedcheck_zdotc.csv',action='write')
      write(fochk,'(a)')'matsize,CPU,GPU'

!      do while ( matsize <= 1024  )
      do while ( matsize <= 2**25  )
      n = matsize 

      lda = matsize
      ldb = matsize
      ldc = matsize

      allocate(zxh(n),zxl(n),zyh(n),zyl(n))

      call imaggen1mat(1,n,zxh,zxl)
      call imaggen1mat(1,n,zyh,zyl)

      call gettimeofday_sec(tini)

      call ddzdotc(n,zxh,zxl,incx,zyh,zyl,incy,zzh,zzl)

      tdiff_cpu = getsec(tini)
      
      call gettimeofday_sec(tini)

      call gddzdotc_host(n,zxh,zxl,incx,zyh,zyl,incy,zzh,zzl)

      tdiff_gpu = getsec(tini)

      write(*,    1000) matsize,tdiff_cpu,tdiff_gpu
      write(fochk,1000) matsize,tdiff_cpu,tdiff_gpu

      deallocate(zxh,zxl,zyh,zyl)

      matsize = matsize*2
      end do

      close(fochk)

 1000 format(i10,',',1pe16.8,',',1pe16.8)
      stop
      end program
