      program speedcheck
      implicit none

      double complex,allocatable :: ah(:,:),al(:,:)
      double complex,allocatable :: bh(:,:),bl(:,:)
      double complex,allocatable :: xh(:),xl(:)
      double complex,allocatable :: yh(:),yl(:)
      integer m,n,k
      integer incx,incy
      integer lda,ldb,ldc
      integer matsize
      double complex :: alphah,alphal,betah,betal
      character :: trans = 'N'
      character :: side = 'l'
      character :: uplo = 'l'
      character :: diag = 'n'

      real(8) :: getsec
      real(8) :: tini, tdiff_cpu, tdiff_gpu

      integer,parameter :: fochk = 21

      incx = 1
      incy = 1

      matsize = 1

      open(fochk,file='speedcheck_zher2.csv',action='write')
      write(fochk,'(a)')'matsize,CPU,GPU'

!      do while ( matsize <= 1024  )
      do while ( matsize <= 2**14  )
      n = matsize 

      lda = matsize
      ldb = matsize
      ldc = matsize

      allocate(ah(n,n),al(n,n),bh(n,n),bl(n,n),xh(n),xl(n),yh(n),yl(n))

      call realgen1mat(n,n,ah,al)

      call realgen1mat(1,1,alphah,alphal)
      call realgen1mat(1,1,betah,betal)

      call realgen1mat(1,n,xh,xl)
      call realgen1mat(1,n,yh,yl)

      bh = ah
      bl = al

      call gettimeofday_sec(tini)

      call ddzher2(uplo,n,alphah,alphal,xh,xl,incx,
     &             yh,yl,incy,ah,al,lda)

      tdiff_cpu = getsec(tini)
      
      call gettimeofday_sec(tini)

      call gddzher2_host(uplo,n,alphah,alphal,xh,xl,incx,
     &                  yh,yl,incy,bh,bl,lda)

      tdiff_gpu = getsec(tini)

      write(*,    1000) matsize,tdiff_cpu,tdiff_gpu
      write(fochk,1000) matsize,tdiff_cpu,tdiff_gpu

      deallocate(ah,al,bh,bl,xh,xl,yh,yl)

      matsize = matsize*2
      end do

      close(fochk)

 1000 format(i8,',',1pe16.8,',',1pe16.8)
      stop
      end program
