      program speedcheck
      implicit none

      double complex,allocatable :: ah(:,:),al(:,:)
      double complex,allocatable :: bh(:,:),bl(:,:)
      double complex,allocatable :: ch(:,:),cl(:,:)
      double complex,allocatable :: dh(:,:),dl(:,:)
      integer m,n,k
      integer lda,ldb,ldc
      integer matsize
      double complex :: alphah,alphal,betah,betal
      character :: transa = 'n',transb = 'n',trans = 'n'
      character :: side = 'l'
      character :: uplo = 'l'
      character :: diag = 'n'

      real(8) :: getsec
      real(8) :: tini, tdiff_cpu, tdiff_gpu

      integer,parameter :: fochk = 21

      matsize = 1

      open(fochk,file='speedcheck_zherk.csv',action='write')
      write(fochk,'(a)')'matsize,CPU,GPU'

      do while ( matsize <= 1024  )
      n = matsize 

      lda = matsize
      ldb = matsize
      ldc = matsize

      allocate(ah(n,n),al(n,n),bh(n,n),bl(n,n),ch(n,n),cl(n,n),
     &         dh(n,n),dl(n,n))

      call imaggen1mat(n,n,ah,al)
      call imaggen1mat(n,n,bh,bl)

      call imaggen1mat(1,1,alphah,alphal)
      call imaggen1mat(1,1,betah,betal)

      call imaggen1mat(n,n,ch,cl)

      dh = ch
      dl = cl

      call gettimeofday_sec(tini)

      call ddzherk(uplo,trans,n,n,alphah,alphal,ah,al,
     &             lda,betah,betal,ch,cl,ldc)

      tdiff_cpu = getsec(tini)
      
      call gettimeofday_sec(tini)

      call gddzherk_host(uplo,trans,n,n,alphah,alphal,ah,al,
     &                  lda,betah,betal,dh,dl,ldc)

      tdiff_gpu = getsec(tini)

      write(*,    1000) matsize,tdiff_cpu,tdiff_gpu
      write(fochk,1000) matsize,tdiff_cpu,tdiff_gpu

      deallocate(ah,al,bh,bl,ch,cl,dh,dl)

      matsize = matsize*2
      end do

      close(fochk)

 1000 format(i8,',',1pe16.8,',',1pe16.8)
      stop
      end program
