#include "gddcommon.h"

void
gddrotg_host_( double*dah, double* dal, double*dbh, double*dbl,
              double*ch, double*cl, double*sh, double*sl )
{
	double * ddah,*ddal,*ddbh,*ddbl,*dch,*dcl,*dsh,*dsl;
    if(
       CUBLAS_STATUS_SUCCESS !=
        cublasAlloc( 1, sizeof( double ), (void**) &ddah )
      || CUBLAS_STATUS_SUCCESS !=
        cublasAlloc( 1, sizeof( double ), (void**) &ddal )
      || CUBLAS_STATUS_SUCCESS !=
        cublasAlloc( 1, sizeof( double ), (void**) &ddbh )
      || CUBLAS_STATUS_SUCCESS !=
        cublasAlloc( 1, sizeof( double ), (void**) &ddbl )
      || CUBLAS_STATUS_SUCCESS !=
        cublasAlloc( 1, sizeof( double ), (void**) &dch )
      || CUBLAS_STATUS_SUCCESS !=
        cublasAlloc( 1, sizeof( double ), (void**) &dcl )
      || CUBLAS_STATUS_SUCCESS !=
        cublasAlloc( 1, sizeof( double ), (void**) &dsh )
      || CUBLAS_STATUS_SUCCESS !=
        cublasAlloc( 1, sizeof( double ), (void**) &dsl )
      )
    {
/*	 Memory allocation failed */
        cublasFree( ddah );
        cublasFree( ddal );
        cublasFree( ddbh );
        cublasFree( ddbl );
        cublasFree( dch );
        cublasFree( dcl );
        cublasFree( dsh );
        cublasFree( dsl );
	exit(-1);
    }
    else
    {
        cublasSetVector( 1, sizeof( double ), dah, 1, ddah, 1 );
        cublasSetVector( 1, sizeof( double ), dal, 1, ddal, 1 );
        cublasSetVector( 1, sizeof( double ), dbh, 1, ddbh, 1 );
        cublasSetVector( 1, sizeof( double ), dbl, 1, ddbl, 1 );
        cublasSetVector( 1, sizeof( double ), ch, 1, dch, 1 );
        cublasSetVector( 1, sizeof( double ), cl, 1, dcl, 1 );
        cublasSetVector( 1, sizeof( double ), sh, 1, dsh, 1 );
        cublasSetVector( 1, sizeof( double ), sl, 1, dsl, 1 );
    }


    gddrotg(ddah,ddal,ddbh,ddbl,dch,dcl,dsh,dsl);

    cublasGetVector( 1, sizeof( double ), ddah, 1, dah, 1 );
    cublasGetVector( 1, sizeof( double ), ddal, 1, dal, 1 );
    cublasGetVector( 1, sizeof( double ), ddbh, 1, dbh, 1 );
    cublasGetVector( 1, sizeof( double ), ddbl, 1, dbl, 1 );
    cublasGetVector( 1, sizeof( double ),  dch, 1,  ch, 1 );
    cublasGetVector( 1, sizeof( double ),  dcl, 1,  cl, 1 );
    cublasGetVector( 1, sizeof( double ),  dsh, 1,  sh, 1 );
    cublasGetVector( 1, sizeof( double ),  dsl, 1,  sl, 1 );

    cublasFree( ddah );
    cublasFree( ddal );
    cublasFree( ddbh );
    cublasFree( ddbl );
    cublasFree( dch );
    cublasFree( dcl );
    cublasFree( dsh );
    cublasFree( dsl );

}

