#include "gddcommon.h"

#ifdef __cplusplus
extern "C" {
#endif
int
gddtbmv_host_(char*uplo, char*trans, char*diag, int *n,int *k,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx  )
{
    int     btrans = 1;

    if( *trans == 'N' || *trans == 'n' ) btrans = 0;
    int     sizeA =  *lda*(*n);

    int sizex;
    sizex = (*n)*(*incx);

    double *dAh, *dAl, *dxh, *dxl;

    if(
        CUBLAS_STATUS_SUCCESS !=
        cublasAlloc( sizeA, sizeof( double ), (void**) &dAh )
      || CUBLAS_STATUS_SUCCESS !=
        cublasAlloc( sizeA, sizeof( double ), (void**) &dAl )
      || CUBLAS_STATUS_SUCCESS !=
        cublasAlloc( sizex, sizeof( double ), (void**) &dxh )
      || CUBLAS_STATUS_SUCCESS !=
        cublasAlloc( sizex, sizeof( double ), (void**) &dxl )
      )
    {
/*	 Memory allocation failed */
        cublasFree( dAh );
        cublasFree( dAl );
	cublasFree( dxh );
	cublasFree( dxl );
        printf( "Device Malloc Error\n" );
        return -1;
    }
    else
    {
        /* Send Matrices(column-majorでFortranと一緒)  */
        cublasSetVector( sizeA, sizeof( double ), Ah, 1, dAh, 1 );
        cublasSetVector( sizeA, sizeof( double ), Al, 1, dAl, 1 );
        cublasSetVector( sizex, sizeof( double ), xh, 1, dxh, 1 );
        cublasSetVector( sizex, sizeof( double ), xl, 1, dxl, 1 );
    }

    gddtbmv(uplo,trans,diag, n,k, dAh,  dAl,  lda, dxh,
        dxl,  incx);


    /* Get From Device Memory */
    cublasGetVector( sizex, sizeof( double ), dxh, 1, xh, 1 );
    cublasGetVector( sizex, sizeof( double ), dxl, 1, xl, 1 );

    /* Free Device Memories */
    cublasFree( dAh );
    cublasFree( dAl );
    cublasFree( dxh );
    cublasFree( dxl );

    return 0;
}
#ifdef __cplusplus
}
#endif

