#include "gddcommon.h"
#include "gddblas_host.h"

#ifdef __cplusplus
extern "C" {
#endif


int
gddtrsv_host_multigpu_(char*uplo, char*trans, char*diag, int *n,
              double *Ah, double *Al, int *lda, double * xh, double *xl,
              int *incx  )
{
	char side = 'L';
	double alphah = 1.0;
	double alphal = 0.0;
	int ione = 1;

	double *hxh,*hxl;

	cudaMallocHost((void **)&hxh,(*n)*sizeof(double));
	cudaMallocHost((void **)&hxl,(*n)*sizeof(double));

	vector_copy(*n,xh,xl,*incx,hxh,hxl,ione);

	gddtrsm_host_multigpu_(&side,uplo,trans,
			diag,n,&ione,
			&alphah,&alphal,
			Ah,Al,lda,hxh,hxl,n);
	vector_copy(*n,hxh,hxl,ione,xh,xl,*incx);

	cudaFreeHost(hxh);
	cudaFreeHost(hxl);
	return 0;
}
#ifdef __cplusplus
}
#endif

